=== removed file 'olive/__init__.py'
=== renamed file 'olive/frontend/gtk/__init__.py' => 'olive/__init__.py'
=== renamed file 'olive/frontend/gtk/add.py' => 'olive/add.py'
=== renamed file 'olive/frontend/gtk/bookmark.py' => 'olive/bookmark.py'
=== renamed file 'olive/frontend/gtk/branch.py' => 'olive/branch.py'
=== renamed file 'olive/frontend/gtk/checkout.py' => 'olive/checkout.py'
=== renamed file 'olive/frontend/gtk/commit.py' => 'olive/commit.py'
=== renamed file 'olive/frontend/gtk/dialog.py' => 'olive/dialog.py'
=== renamed file 'olive/frontend/gtk/diff.py' => 'olive/diff.py'
=== removed directory 'olive/frontend'
=== removed file 'olive/frontend/__init__.py'
=== removed directory 'olive/frontend/gtk'
=== removed directory 'olive/frontend/gtk/viz'
=== removed file 'olive/frontend/gtk/viz/__init__.py'
--- olive/frontend/gtk/viz/__init__.py	2006-08-10 17:25:30 +0000
+++ olive/frontend/gtk/viz/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,34 +0,0 @@
-# Modified for use with Olive:
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Original copyright holder:
-# Copyright (C) 2005 by Canonical Ltd. (Scott James Remnant <scott@ubuntu.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""GTK+ Branch Visualisation.
-
-This is a bzr plugin that adds a new 'visualise' (alias: 'viz') command
-which opens a GTK+ window to allow you to see the history of the branch
-and relationships between revisions in a visual manner.
-
-It's somewhat based on a screenshot I was handed of gitk.  The top half
-of the window shows the revisions in a list with a graph drawn down the
-left hand side that joins them up and shows how they relate to each other.
-The bottom hald of the window shows the details for the selected revision.
-"""
-
-__copyright__ = "Copyright © 2005 Canonical Ltd."
-__author__    = "Scott James Remnant <scott@ubuntu.com>"
-

=== removed file 'olive/frontend/gtk/viz/branchwin.py'
--- olive/frontend/gtk/viz/branchwin.py	2006-09-02 13:51:41 +0000
+++ olive/frontend/gtk/viz/branchwin.py	1970-01-01 00:00:00 +0000
@@ -1,438 +0,0 @@
-# Modified for use with Olive:
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Original copyright holder:
-# Copyright (C) 2005 by Canonical Ltd. (Scott James Remnant <scott@ubuntu.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Branch window.
-
-This module contains the code to manage the branch information window,
-which contains both the revision graph and details panes.
-"""
-
-__copyright__ = "Copyright © 2005 Canonical Ltd."
-__author__    = "Scott James Remnant <scott@ubuntu.com>"
-
-
-import gtk
-import gobject
-import pango
-
-from bzrlib.osutils import format_date
-
-from graph import distances, graph, same_branch
-from graphcell import CellRendererGraph
-
-
-class BranchWindow(gtk.Window):
-    """Branch window.
-
-    This object represents and manages a single window containing information
-    for a particular branch.
-    """
-
-    def __init__(self, app=None):
-        gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
-        self.set_border_width(0)
-        self.set_title("bzrk")
-
-        self.app = app
-
-        # Use three-quarters of the screen by default
-        screen = self.get_screen()
-        monitor = screen.get_monitor_geometry(0)
-        width = int(monitor.width * 0.75)
-        height = int(monitor.height * 0.75)
-        self.set_default_size(width, height)
-
-        # FIXME AndyFitz!
-        icon = self.render_icon(gtk.STOCK_INDEX, gtk.ICON_SIZE_BUTTON)
-        self.set_icon(icon)
-
-        self.accel_group = gtk.AccelGroup()
-        self.add_accel_group(self.accel_group)
-
-        self.construct()
-
-    def construct(self):
-        """Construct the window contents."""
-        vbox = gtk.VBox(spacing=0)
-        self.add(vbox)
-
-        vbox.pack_start(self.construct_navigation(), expand=False, fill=True)
-
-        paned = gtk.VPaned()
-        paned.pack1(self.construct_top(), resize=True, shrink=False)
-        paned.pack2(self.construct_bottom(), resize=False, shrink=True)
-        paned.show()
-        vbox.pack_start(paned, expand=True, fill=True)
-        vbox.set_focus_child(paned)
-
-        vbox.show()
-
-    def construct_top(self):
-        """Construct the top-half of the window."""
-        scrollwin = gtk.ScrolledWindow()
-        scrollwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
-        scrollwin.set_shadow_type(gtk.SHADOW_IN)
-        scrollwin.show()
-
-        self.treeview = gtk.TreeView()
-        self.treeview.set_rules_hint(True)
-        self.treeview.set_search_column(4)
-        self.treeview.connect("cursor-changed", self._treeview_cursor_cb)
-        self.treeview.connect("row-activated", self._treeview_row_activated_cb)
-        scrollwin.add(self.treeview)
-        self.treeview.show()
-
-        cell = CellRendererGraph()
-        column = gtk.TreeViewColumn()
-        column.set_resizable(True)
-        column.pack_start(cell, expand=False)
-        column.add_attribute(cell, "node", 1)
-        column.add_attribute(cell, "in-lines", 2)
-        column.add_attribute(cell, "out-lines", 3)
-        self.treeview.append_column(column)
-
-        cell = gtk.CellRendererText()
-        cell.set_property("width-chars", 40)
-        cell.set_property("ellipsize", pango.ELLIPSIZE_END)
-        column = gtk.TreeViewColumn(_('Message'))
-        column.set_resizable(True)
-        column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 4)
-        self.treeview.append_column(column)
-
-        cell = gtk.CellRendererText()
-        cell.set_property("width-chars", 40)
-        cell.set_property("ellipsize", pango.ELLIPSIZE_END)
-        column = gtk.TreeViewColumn(_('Committer'))
-        column.set_resizable(True)
-        column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 5)
-        self.treeview.append_column(column)
-
-        cell = gtk.CellRendererText()
-        cell.set_property("ellipsize", pango.ELLIPSIZE_END)
-        column = gtk.TreeViewColumn(_('Date'))
-        column.set_resizable(True)
-        column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 6)
-        self.treeview.append_column(column)
-
-        return scrollwin
-
-    def construct_navigation(self):
-        """Construct the navigation buttons."""
-        frame = gtk.Frame()
-        frame.set_shadow_type(gtk.SHADOW_OUT)
-        frame.show()
-        
-        hbox = gtk.HBox(spacing=12)
-        frame.add(hbox)
-        hbox.show()
-
-        self.back_button = gtk.Button(stock=gtk.STOCK_GO_BACK)
-        self.back_button.set_relief(gtk.RELIEF_NONE)
-        self.back_button.add_accelerator("clicked", self.accel_group, ord('['),
-                                         0, 0)
-        self.back_button.connect("clicked", self._back_clicked_cb)
-        hbox.pack_start(self.back_button, expand=False, fill=True)
-        self.back_button.show()
-
-        self.fwd_button = gtk.Button(stock=gtk.STOCK_GO_FORWARD)
-        self.fwd_button.set_relief(gtk.RELIEF_NONE)
-        self.fwd_button.add_accelerator("clicked", self.accel_group, ord(']'),
-                                        0, 0)
-        self.fwd_button.connect("clicked", self._fwd_clicked_cb)
-        hbox.pack_start(self.fwd_button, expand=False, fill=True)
-        self.fwd_button.show()
-
-        return frame
-
-    def construct_bottom(self):
-        """Construct the bottom half of the window."""
-        scrollwin = gtk.ScrolledWindow()
-        scrollwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
-        scrollwin.set_shadow_type(gtk.SHADOW_NONE)
-        (width, height) = self.get_size()
-        scrollwin.set_size_request(width, int(height / 2.5))
-        scrollwin.show()
-
-        vbox = gtk.VBox(False, spacing=6)
-        vbox.set_border_width(6)
-        scrollwin.add_with_viewport(vbox)
-        vbox.show()
-
-        table = gtk.Table(rows=4, columns=2)
-        table.set_row_spacings(6)
-        table.set_col_spacings(6)
-        vbox.pack_start(table, expand=False, fill=True)
-        table.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        label = gtk.Label()
-        label.set_markup(_('<b>Revision:</b>'))
-        align.add(label)
-        table.attach(align, 0, 1, 0, 1, gtk.FILL, gtk.FILL)
-        label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        self.revid_label = gtk.Label()
-        self.revid_label.set_selectable(True)
-        align.add(self.revid_label)
-        table.attach(align, 1, 2, 0, 1, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        self.revid_label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        label = gtk.Label()
-        label.set_markup(_('<b>Committer:</b>'))
-        align.add(label)
-        table.attach(align, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
-        label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        self.committer_label = gtk.Label()
-        self.committer_label.set_selectable(True)
-        align.add(self.committer_label)
-        table.attach(align, 1, 2, 1, 2, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        self.committer_label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        label = gtk.Label()
-        label.set_markup(_('<b>Branch nick:</b>'))
-        align.add(label)
-        table.attach(align, 0, 1, 2, 3, gtk.FILL, gtk.FILL)
-        label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        self.branchnick_label = gtk.Label()
-        self.branchnick_label.set_selectable(True)
-        align.add(self.branchnick_label)
-        table.attach(align, 1, 2, 2, 3, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        self.branchnick_label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        label = gtk.Label()
-        label.set_markup(_('<b>Timestamp:</b>'))
-        align.add(label)
-        table.attach(align, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
-        label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
-        self.timestamp_label = gtk.Label()
-        self.timestamp_label.set_selectable(True)
-        align.add(self.timestamp_label)
-        table.attach(align, 1, 2, 3, 4, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        self.timestamp_label.show()
-        align.show()
-
-        self.parents_table = gtk.Table(rows=1, columns=2)
-        self.parents_table.set_row_spacings(3)
-        self.parents_table.set_col_spacings(6)
-        self.parents_table.show()
-        vbox.pack_start(self.parents_table, expand=False, fill=True)
-        self.parents_widgets = []
-
-        label = gtk.Label()
-        label.set_markup(_('<b>Parents:</b>'))
-        align = gtk.Alignment(0.0, 0.5)
-        align.add(label)
-        self.parents_table.attach(align, 0, 1, 0, 1, gtk.FILL, gtk.FILL)
-        label.show()
-        align.show()
-
-        self.message_buffer = gtk.TextBuffer()
-        textview = gtk.TextView(self.message_buffer)
-        textview.set_editable(False)
-        textview.set_wrap_mode(gtk.WRAP_WORD)
-        textview.modify_font(pango.FontDescription("Monospace"))
-        vbox.pack_start(textview, expand=True, fill=True)
-        textview.show()
-
-        return scrollwin
-
-    def set_branch(self, branch, start, maxnum):
-        """Set the branch and start position for this window.
-
-        Creates a new TreeModel and populates it with information about
-        the new branch before updating the window title and model of the
-        treeview itself.
-        """
-        self.branch = branch
-
-        # [ revision, node, last_lines, lines, message, committer, timestamp ]
-        self.model = gtk.ListStore(gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   gobject.TYPE_PYOBJECT,
-                                   str, str, str)
-        self.index = {}
-        index = 0
-
-        last_lines = []
-        (self.revisions, colours, self.children, self.parent_ids,
-         merge_sorted) = distances(branch, start)
-        for (index, (revision, node, lines)) in enumerate(graph(
-                self.revisions, colours, merge_sorted)):
-            # FIXME: at this point we should be able to show the graph order
-            # and lines with no message or commit data - and then incrementally
-            # fill the timestamp, committer etc data as desired.
-            message = revision.message.split("\n")[0]
-            if revision.committer is not None:
-                timestamp = format_date(revision.timestamp, revision.timezone)
-            else:
-                timestamp = None
-            self.model.append([revision, node, last_lines, lines,
-                               message, revision.committer, timestamp])
-            self.index[revision] = index
-            last_lines = lines
-            if maxnum is not None and index > maxnum:
-                break
-
-        self.set_title(branch.nick + " - bzrk")
-        self.treeview.set_model(self.model)
-
-    def _treeview_cursor_cb(self, *args):
-        """Callback for when the treeview cursor changes."""
-        (path, col) = self.treeview.get_cursor()
-        revision = self.model[path][0]
-
-        self.back_button.set_sensitive(len(self.parent_ids[revision]) > 0)
-        self.fwd_button.set_sensitive(len(self.children[revision]) > 0)
-
-        if revision.committer is not None:
-            branchnick = ""
-            committer = revision.committer
-            timestamp = format_date(revision.timestamp, revision.timezone)
-            message = revision.message
-            try:
-                branchnick = revision.properties['branch-nick']
-            except KeyError:
-                pass
-
-        else:
-            committer = ""
-            timestamp = ""
-            message = ""
-            branchnick = ""
-
-        self.revid_label.set_text(revision.revision_id)
-        self.branchnick_label.set_text(branchnick)
-
-        self.committer_label.set_text(committer)
-        self.timestamp_label.set_text(timestamp)
-        self.message_buffer.set_text(message)
-
-        for widget in self.parents_widgets:
-            self.parents_table.remove(widget)
-
-        self.parents_widgets = []
-        self.parents_table.resize(max(len(self.parent_ids[revision]), 1), 2)
-        
-        for idx, parent_id in enumerate(self.parent_ids[revision]):
-            align = gtk.Alignment(0.0, 0.0)
-            self.parents_widgets.append(align)
-            self.parents_table.attach(align, 1, 2, idx, idx + 1,
-                                      gtk.EXPAND | gtk.FILL, gtk.FILL)
-            align.show()
-
-            hbox = gtk.HBox(False, spacing=6)
-            align.add(hbox)
-            hbox.show()
-
-            image = gtk.Image()
-            image.set_from_stock(
-                gtk.STOCK_FIND, gtk.ICON_SIZE_SMALL_TOOLBAR)
-            image.show()
-
-            button = gtk.Button()
-            button.add(image)
-            button.set_sensitive(self.app is not None)
-            button.connect("clicked", self._show_clicked_cb,
-                           revision.revision_id, parent_id)
-            hbox.pack_start(button, expand=False, fill=True)
-            button.show()
-
-            button = gtk.Button(parent_id)
-            button.set_use_underline(False)
-            button.connect("clicked", self._go_clicked_cb, parent_id)
-            hbox.pack_start(button, expand=False, fill=True)
-            button.show()
-
-
-    def _back_clicked_cb(self, *args):
-        """Callback for when the back button is clicked."""
-        (path, col) = self.treeview.get_cursor()
-        revision = self.model[path][0]
-        if not len(self.parent_ids[revision]):
-            return
-
-        for parent_id in self.parent_ids[revision]:
-            parent = self.revisions[parent_id]
-            if same_branch(revision, parent):
-                self.treeview.set_cursor(self.index[parent])
-                break
-        else:
-            next = self.revisions[self.parent_ids[revision][0]]
-            self.treeview.set_cursor(self.index[next])
-        self.treeview.grab_focus()
-
-    def _fwd_clicked_cb(self, *args):
-        """Callback for when the forward button is clicked."""
-        (path, col) = self.treeview.get_cursor()
-        revision = self.model[path][0]
-        if not len(self.children[revision]):
-            return
-
-        for child in self.children[revision]:
-            if same_branch(child, revision):
-                self.treeview.set_cursor(self.index[child])
-                break
-        else:
-            prev = list(self.children[revision])[0]
-            self.treeview.set_cursor(self.index[prev])
-        self.treeview.grab_focus()
-
-    def _go_clicked_cb(self, widget, revid):
-        """Callback for when the go button for a parent is clicked."""
-        self.treeview.set_cursor(self.index[self.revisions[revid]])
-        self.treeview.grab_focus()
-
-    def _show_clicked_cb(self, widget, revid, parentid):
-        """Callback for when the show button for a parent is clicked."""
-        if self.app is not None:
-            self.app.show_diff(self.branch, revid, parentid)
-        self.treeview.grab_focus()
-
-    def _treeview_row_activated_cb(self, widget, path, col):
-        # TODO: more than one parent
-        """Callback for when a treeview row gets activated."""
-        revision = self.model[path][0]
-        if len(self.parent_ids[revision]) == 0:
-            # Ignore revisions without parent
-            return
-        parent_id = self.parent_ids[revision][0]
-        if self.app is not None:
-            self.app.show_diff(self.branch, revision.revision_id, parent_id)
-        self.treeview.grab_focus()

=== removed file 'olive/frontend/gtk/viz/bzrkapp.py'
--- olive/frontend/gtk/viz/bzrkapp.py	2006-08-10 17:25:30 +0000
+++ olive/frontend/gtk/viz/bzrkapp.py	1970-01-01 00:00:00 +0000
@@ -1,60 +0,0 @@
-# Modified for use with Olive:
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Original copyright holder:
-# Copyright (C) 2005 by Canonical Ltd. (Scott James Remnant <scott@ubuntu.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Application object.
-
-This module contains the application object that manages the windows
-on screen, and can be used to create new windows of various types.
-"""
-
-__copyright__ = "Copyright © 2005 Canonical Ltd."
-__author__    = "Scott James Remnant <scott@ubuntu.com>"
-
-
-import pygtk
-pygtk.require("2.0")
-
-import gtk
-
-from branchwin import BranchWindow
-from diffwin import DiffWindow
-
-
-class BzrkApp(object):
-    """Application manager.
-
-    This object manages the bzrk application, creating and managing
-    individual branch windows and ensuring the application exits when
-    the last window is closed.
-    """
-
-    def show(self, branch, start, maxnum):
-        """Open a new window to show the given branch."""
-        window = BranchWindow(self)
-        window.set_branch(branch, start, maxnum)
-        window.show()
-
-    def show_diff(self, branch, revid, parentid):
-        """Open a new window to show a diff between the given revisions."""
-        window = DiffWindow()
-        rev_tree = branch.repository.revision_tree(revid)
-        parent_tree = branch.repository.revision_tree(parentid)
-        description = revid + " - " + branch.nick
-        window.set_diff(description, rev_tree, parent_tree)
-        window.show()

=== removed file 'olive/frontend/gtk/viz/diffwin.py'
--- olive/frontend/gtk/viz/diffwin.py	2006-09-02 13:51:41 +0000
+++ olive/frontend/gtk/viz/diffwin.py	1970-01-01 00:00:00 +0000
@@ -1,193 +0,0 @@
-# Modified for use with Olive:
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Original copyright holder:
-# Copyright (C) 2005 by Canonical Ltd. (Scott James Remnant <scott@ubuntu.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Difference window.
-
-This module contains the code to manage the diff window which shows
-the changes made between two revisions on a branch.
-"""
-
-__copyright__ = "Copyright © 2005 Canonical Ltd."
-__author__    = "Scott James Remnant <scott@ubuntu.com>"
-
-
-from cStringIO import StringIO
-
-import gtk
-import pango
-import sys
-
-try:
-    import gtksourceview
-    have_gtksourceview = True
-except ImportError:
-    have_gtksourceview = False
-
-import bzrlib
-if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-    # function deprecated after 0.9
-    from bzrlib.delta import compare_trees
-
-from bzrlib.diff import show_diff_trees
-from bzrlib.errors import NoSuchFile
-
-
-class DiffWindow(gtk.Window):
-    """Diff window.
-
-    This object represents and manages a single window containing the
-    differences between two revisions on a branch.
-    """
-
-    def __init__(self):
-        gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
-        self.set_border_width(0)
-        self.set_title("bzrk diff")
-
-        # Use two thirds of the screen by default
-        screen = self.get_screen()
-        monitor = screen.get_monitor_geometry(0)
-        width = int(monitor.width * 0.66)
-        height = int(monitor.height * 0.66)
-        self.set_default_size(width, height)
-
-        self.construct()
-
-    def construct(self):
-        """Construct the window contents."""
-        # The   window  consists  of   a  pane   containing:  the
-        # hierarchical list  of files on  the left, and  the diff
-        # for the currently selected file on the right.
-        pane = gtk.HPaned()
-        self.add(pane)
-        pane.show()
- 
-        # The file hierarchy: a scrollable treeview
-        scrollwin = gtk.ScrolledWindow()
-        scrollwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
-        scrollwin.set_shadow_type(gtk.SHADOW_IN)
-        pane.pack1(scrollwin)
-        scrollwin.show()
-
-        self.model = gtk.TreeStore(str, str)
-        self.treeview = gtk.TreeView(self.model)
-        self.treeview.set_headers_visible(False)
-        self.treeview.set_search_column(1)
-        self.treeview.connect("cursor-changed", self._treeview_cursor_cb)
-        scrollwin.add(self.treeview)
-        self.treeview.show()
-
-        cell = gtk.CellRendererText()
-        cell.set_property("width-chars", 20)
-        column = gtk.TreeViewColumn()
-        column.pack_start(cell, expand=True)
-        column.add_attribute(cell, "text", 0)
-        self.treeview.append_column(column)
-
-        # The diffs of the  selected file: a scrollable source or
-        # text view
-        scrollwin = gtk.ScrolledWindow()
-        scrollwin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
-        scrollwin.set_shadow_type(gtk.SHADOW_IN)
-        pane.pack2(scrollwin)
-        scrollwin.show()
-
-        if have_gtksourceview:
-            self.buffer = gtksourceview.SourceBuffer()
-            slm = gtksourceview.SourceLanguagesManager()
-            gsl = slm.get_language_from_mime_type("text/x-patch")
-            self.buffer.set_language(gsl)
-            self.buffer.set_highlight(True)
-
-            sourceview = gtksourceview.SourceView(self.buffer)
-        else:
-            self.buffer = gtk.TextBuffer()
-            sourceview = gtk.TextView(self.buffer)
-
-        sourceview.set_editable(False)
-        sourceview.modify_font(pango.FontDescription("Monospace"))
-        scrollwin.add(sourceview)
-        sourceview.show()
-
-    def set_diff(self, description, rev_tree, parent_tree):
-        """Set the differences showed by this window.
-
-        Compares the two trees and populates the window with the
-        differences.
-        """
-        self.rev_tree = rev_tree
-        self.parent_tree = parent_tree
-
-        self.model.clear()
-
-        if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-            delta = compare_trees(self.parent_tree, self.rev_tree)
-        else:
-            delta = self.rev_tree.changes_from(self.parent_tree)
-
-        self.model.append(None, [ _('Complete Diff'), "" ])
-
-        if len(delta.added):
-            titer = self.model.append(None, [ _('Added'), None ])
-            for path, id, kind in delta.added:
-                self.model.append(titer, [ path, path ])
-
-        if len(delta.removed):
-            titer = self.model.append(None, [ _('Removed'), None ])
-            for path, id, kind in delta.removed:
-                self.model.append(titer, [ path, path ])
-
-        if len(delta.renamed):
-            titer = self.model.append(None, [ _('Renamed'), None ])
-            for oldpath, newpath, id, kind, text_modified, meta_modified \
-                    in delta.renamed:
-                self.model.append(titer, [ oldpath, newpath ])
-
-        if len(delta.modified):
-            titer = self.model.append(None, [ _('Modified'), None ])
-            for path, id, kind, text_modified, meta_modified in delta.modified:
-                self.model.append(titer, [ path, path ])
-
-        self.treeview.expand_all()
-        self.set_title(description + " - bzrk diff")
-
-    def set_file(self, file_path):
-        tv_path = None
-        for data in self.model:
-            for child in data.iterchildren():
-                if child[0] == file_path or child[1] == file_path:
-                    tv_path = child.path
-                    break
-        if tv_path is None:
-            raise NoSuchFile(file_path)
-        self.treeview.set_cursor(tv_path)
-        self.treeview.scroll_to_cell(tv_path)
-
-    def _treeview_cursor_cb(self, *args):
-        """Callback for when the treeview cursor changes."""
-        (path, col) = self.treeview.get_cursor()
-        specific_files = [ self.model[path][1] ]
-        if specific_files == [ None ]:
-            return
-        elif specific_files == [ "" ]:
-            specific_files = []
-
-        s = StringIO()
-        show_diff_trees(self.parent_tree, self.rev_tree, s, specific_files)
-        self.buffer.set_text(s.getvalue().decode(sys.getdefaultencoding(), 'replace'))

=== removed file 'olive/frontend/gtk/viz/graph.py'
--- olive/frontend/gtk/viz/graph.py	2006-08-10 17:25:30 +0000
+++ olive/frontend/gtk/viz/graph.py	1970-01-01 00:00:00 +0000
@@ -1,469 +0,0 @@
-# Modified for use with Olive:
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Original copyright holder:
-# Copyright (C) 2005 by Canonical Ltd. (Scott James Remnant <scott@ubuntu.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Directed graph production.
-
-This module contains the code to produce an ordered directed graph of a
-bzr branch, such as we display in the tree view at the top of the bzrk
-window.
-"""
-
-__copyright__ = "Copyright © 2005 Canonical Ltd."
-__author__    = "Scott James Remnant <scott@ubuntu.com>"
-
-
-from bzrlib.tsort import merge_sort
-
-
-class DummyRevision(object):
-    """Dummy bzr revision.
-
-    Sometimes, especially in older bzr branches, a revision is referenced
-    as the parent of another but not actually present in the branch's store.
-    When this happens we use an instance of this class instead of the real
-    Revision object (which we can't get).
-    """
-
-    def __init__(self, revid):
-        self.revision_id = revid
-        self.parent_ids = []
-        self.committer = None
-        self.message = self.revision_id
-
-
-class RevisionProxy(object):
-    """A revision proxy object.
-
-    This will demand load the revision it represents when the committer or
-    message attributes are accessed in order to populate them. It is 
-    constructed with the revision id and parent_ids list and a repository
-    object to request the revision from when needed.
-    """
-
-    def __init__(self, revid, parent_ids, repository):
-        self.revision_id = revid
-        self.parent_ids = parent_ids
-        self._repository = repository
-        self._revision = None
-
-    def _get_attribute_getter(attr):
-        def get_attribute(self):
-            if self._revision is None:
-                self._load()
-            return getattr(self._revision, attr)
-        return get_attribute
-    committer = property(_get_attribute_getter('committer'))
-    message = property(_get_attribute_getter('message'))
-    properties = property(_get_attribute_getter('properties'))
-    timestamp = property(_get_attribute_getter('timestamp'))
-    timezone = property(_get_attribute_getter('timezone'))
-
-    def _load(self):
-        """Load the revision object."""
-        self._revision = self._repository.get_revision(self.revision_id)
-
-
-class DistanceMethod(object):
-
-    def __init__(self, branch, start):
-        self.branch = branch
-        self.start = start
-        self.revisions = {}
-        self.children = {}
-        self.children_of_id = {start: set()}
-        self.parent_ids_of = {}
-        self.colours = { start: 0 }
-        self.last_colour = 0
-        self.direct_parent_of = {}
-        self.graph = {}
-
-    def fill_caches(self):
-        graph = self.branch.repository.get_revision_graph_with_ghosts([self.start])
-        for revid in graph.ghosts:
-            self.cache_revision(DummyRevision(revid))
-        for revid, parents in graph.get_ancestors().items():
-            self.cache_revision(RevisionProxy(revid, parents, self.branch.repository))
-
-    def cache_revision(self, revision):
-        "Set the caches for a newly retrieved revision."""
-        revid = revision.revision_id
-        # Build a revision cache
-        self.revisions[revid] = revision
-        # Build a children dictionary
-        for parent_id in revision.parent_ids:
-            self.children_of_id.setdefault(parent_id, set()).add(revision)
-        # Build a parents dictionnary, where redundant parents will be removed,
-        # and that will be passed along tothe rest of program.
-        if len(revision.parent_ids) != len(set(revision.parent_ids)):
-            # fix the parent_ids list.
-            parent_ids = []
-            parent_ids_set = set()
-            for parent_id in revision.parent_ids:
-                if parent_id in parent_ids_set:
-                    continue
-                parent_ids.append(parent_id)
-                parent_ids_set.add(parent_id)
-            revision.parent_ids = parent_ids
-        self.parent_ids_of[revision] = list(revision.parent_ids)
-        self.graph[revid] = revision.parent_ids
-
-    def make_children_map(self):
-        revisions = self.revisions
-        return dict((revisions[revid], c)
-                    for (revid, c) in self.children_of_id.iteritems())
-
-    def sort_revisions(self, sorted_revids, maxnum):
-        revisions = self.revisions
-        parent_ids_of = self.parent_ids_of
-        children_of_id = self.children_of_id
-        # Try to compact sequences of revisions on the same branch.
-        distances = {}
-        skipped_revids = []
-        expected_id = sorted_revids[0]
-        pending_ids = []
-        while True:
-            revid = sorted_revids.pop(0)
-            if revid != expected_id:
-                skipped_revids.append(revid)
-                continue
-            revision = revisions[revid]
-            for child in children_of_id[revid]:
-                # postpone if any child is missing
-                if child.revision_id not in distances:
-                    if expected_id not in pending_ids:
-                        pending_ids.append(expected_id)
-                    expected_id = pending_ids.pop(0)
-                    skipped_revids.append(revid)
-                    sorted_revids[:0] = skipped_revids
-                    del skipped_revids[:]
-                    break
-            else:
-                # all children are here, push!
-                distances[revid] = len(distances)
-                if maxnum is not None and len(distances) > maxnum:
-                    # bail out early if a limit was specified
-                    sorted_revids[:0] = skipped_revids
-                    for revid in sorted_revids:
-                        distances[revid] = len(distances)
-                    break
-                # all parents will need to be pushed as soon as possible
-                for parent in parent_ids_of[revision]:
-                    if parent not in pending_ids:
-                        pending_ids.insert(0, parent)
-                if not pending_ids:
-                    break
-                expected_id = pending_ids.pop(0)
-                # if the next expected revid has already been skipped, requeue
-                # the skipped ids, except those that would go right back to the
-                # skipped list.
-                if expected_id in skipped_revids:
-                    pos = skipped_revids.index(expected_id)
-                    sorted_revids[:0] = skipped_revids[pos:]
-                    del skipped_revids[pos:]
-        self.distances = distances
-        return sorted(distances, key=distances.get)
-
-    def choose_colour(self, revid):
-        revision = self.revisions[revid]
-        children_of_id = self.children_of_id
-        parent_ids_of = self.parent_ids_of
-        colours = self.colours
-        # choose colour
-        the_children = children_of_id[revid]
-        if len(the_children) == 1:
-            [child] = the_children
-            if len(parent_ids_of[child]) == 1:
-                # one-one relationship between parent and child, same
-                # colour
-                colours[revid] = colours[child.revision_id]
-            else:
-                self.choose_colour_one_child(revision, child)
-        else:
-            self.choose_colour_many_children(revision, the_children)
-
-    def choose_colour_one_child(self, revision, child):
-        revid = revision.revision_id
-        direct_parent_of = self.direct_parent_of
-        revisions = self.revisions
-        # one child with multiple parents, the first parent with
-        # the same committer gets the colour
-        direct_parent = direct_parent_of.get(child)
-        if direct_parent is None:
-            # if it has not been found yet, find it now and remember
-            for parent_id in self.parent_ids_of[child]:
-                parent_revision = revisions[parent_id]
-                if parent_revision.committer == child.committer:
-                    # found the first parent with the same committer
-                    direct_parent = parent_revision
-                    direct_parent_of[child] = direct_parent
-                    break
-        if direct_parent == revision:
-            self.colours[revid] = self.colours[child.revision_id]
-        else:
-            self.colours[revid] = self.last_colour = self.last_colour + 1
-
-    def choose_colour_many_children(self, revision, the_children):
-        """Colour revision revision."""
-        revid = revision.revision_id
-        direct_parent_of = self.direct_parent_of
-        # multiple children, get the colour of the last displayed child
-        # with the same committer which does not already have its colour
-        # taken
-        available = {}
-        for child in the_children:
-            if child.committer != revision.committer:
-                continue
-            direct_parent = direct_parent_of.get(child)
-            if direct_parent == revision:
-                self.colours[revid] = self.colours[child.revision_id]
-                break
-            # FIXME: Colouring based on whats been displayed MUST be done with 
-            # knowledge of the revisions being output.
-            # until the refactoring to fold graph() into this more compactly is
-            # done, I've disabled this reuse. RBC 20060403
-            # if direct_parent is None:
-            #     available[child] = distances[child.revision_id] 
-            #   .. it will be something like available[child] =  \
-            #  revs[child.revision_id][0] - which is the sequence number
-        else:
-            if available:
-                sorted_children = sorted(available, key=available.get)
-                child = sorted_children[-1]
-                direct_parent_of[child] = revision
-                self.colours[revid] = self.colours[child.revision_id]
-            else:
-                # no candidate children is available, pick the next
-                # colour
-                self.colours[revid] = self.last_colour = self.last_colour + 1
-
-
-def distances(branch, start):
-    """Sort the revisions.
-
-    Traverses the branch revision tree starting at start and produces an
-    ordered list of revisions such that a revision always comes after
-    any revision it is the parent of.
-
-    Returns a tuple of (revids, revisions, colours, children)
-    """
-    distance = DistanceMethod(branch, start)
-    distance.fill_caches()
-    distance.merge_sorted = merge_sort(distance.graph, distance.start)
-    children = distance.make_children_map()
-    
-    for seq, revid, merge_depth, end_of_merge in distance.merge_sorted:
-        distance.choose_colour(revid)
-
-    revisions = distance.revisions
-    colours = distance.colours
-    parent_ids_of = distance.parent_ids_of
-    return (revisions, colours, children, parent_ids_of, distance.merge_sorted)
-
-
-def graph(revisions, colours, merge_sorted):
-    """Produce a directed graph of a bzr branch.
-
-    For each revision it then yields a tuple of (revision, node, lines).
-    If the revision is only referenced in the branch and not present in the
-    store, revision will be a DummyRevision object, otherwise it is the bzr
-    Revision object with the meta-data for the revision.
-
-    Node is a tuple of (column, colour) with column being a zero-indexed
-    column number of the graph that this revision represents and colour
-    being a zero-indexed colour (which doesn't specify any actual colour
-    in particular) to draw the node in.
-
-    Lines is a list of tuples which represent lines you should draw away
-    from the revision, if you also need to draw lines into the revision
-    you should use the lines list from the previous iteration.  Each
-    typle in the list is in the form (start, end, colour) with start and
-    end being zero-indexed column numbers and colour as in node.
-
-    It's up to you how to actually draw the nodes and lines (straight,
-    curved, kinked, etc.) and to pick the actual colours for each index.
-    """
-    if not len(merge_sorted):
-        return
-    # split merge_sorted into a map:
-    revs = {}
-    # FIXME: get a hint on this from the merge_sorted data rather than
-    # calculating it ourselves
-    # mapping from rev_id to the sequence number of the next lowest rev
-    next_lower_rev = {}
-    # mapping from rev_id to next-in-branch-revid - may be None for end
-    # of branch
-    next_branch_revid = {}
-    # the stack we are in in the sorted data for determining which 
-    # next_lower_rev to set. It is a stack which has one list at each
-    # depth - the ids at that depth that need the same id allocated.
-    current_stack = [[]]
-    for seq, revid, indent, end_merge in merge_sorted:
-        revs[revid] = (seq, indent, end_merge)
-        if indent == len(current_stack):
-            # new merge group starts
-            current_stack.append([revid])
-        elif indent == len(current_stack) - 1:
-            # part of the current merge group
-            current_stack[-1].append(revid)
-        else:
-            # end of a merge group
-            while current_stack[-1]:
-                stack_rev_id = current_stack[-1].pop()
-                # record the next lower rev for this rev:
-                next_lower_rev[stack_rev_id] = seq
-                # if this followed a non-end-merge rev in this group note that
-                if len(current_stack[-1]):
-                    if not revs[current_stack[-1][-1]][2]:
-                        next_branch_revid[current_stack[-1][-1]] = stack_rev_id
-            current_stack.pop()
-            # append to the now-current merge group
-            current_stack[-1].append(revid)
-    # assign a value to all the depth 0 revisions
-    while current_stack[-1]:
-        stack_rev_id = current_stack[-1].pop()
-        # record the next lower rev for this rev:
-        next_lower_rev[stack_rev_id] = len(merge_sorted)
-        # if this followed a non-end-merge rev in this group note that
-        if len(current_stack[-1]):
-            if not revs[current_stack[-1][-1]][2]:
-                next_branch_revid[current_stack[-1][-1]] = stack_rev_id
-
-    # a list of the current revisions we are drawing lines TO indicating
-    # the sequence of their lines on the screen.
-    # i.e. [A, B, C] means that the line to A, to B, and to C are in
-    # (respectively), 0, 1, 2 on the screen.
-    hanging = [merge_sorted[0][1]]
-    for seq, revid, indent, end_merge in merge_sorted:
-        # a list of the lines to draw: their position in the
-        # previous row, their position in this row, and the colour
-        # (which is the colour they are routing to).
-        lines = []
-
-        new_hanging = []
-
-        for h_idx, hang in enumerate(hanging):
-            # one of these will be the current lines node:
-            # we are drawing a line. h_idx 
-            if hang == revid:
-                # we have found the current lines node
-                node = (h_idx, colours[revid])
-
-                # note that we might have done the main parent
-                drawn_parents = set()
-
-                def draw_line(from_idx, to_idx, revision_id):
-                    try:
-                        n_idx = new_hanging.index(revision_id)
-                    except ValueError:
-                        # force this to be vertical at the place this rev was
-                        # drawn.
-                        new_hanging.insert(to_idx, revision_id)
-                        n_idx = to_idx
-                    lines.append((from_idx, n_idx, colours[revision_id]))
-
-                
-                # we want to draw a line to the next commit on 'this' branch
-                if not end_merge:
-                    # drop this line first.
-                    parent_id = next_branch_revid[revid]
-                    draw_line(h_idx, h_idx, parent_id)
-                    # we have drawn this parent
-                    drawn_parents.add(parent_id)
-                else:
-                    # this is the last revision in a 'merge', show where it came from
-                    if len(revisions[revid].parent_ids) > 1:
-                        # having > 1
-                        # parents means this commit was a merge, and being
-                        # the end point of a merge group means that all
-                        # the parent revisions were merged into branches
-                        # to the left of this before this was committed
-                        # - so we want to show this as a new branch from
-                        # those revisions.
-                        # to do this, we show the parent with the lowest
-                        # sequence number, which is the one that this
-                        # branch 'spawned from', and no others.
-                        # If this sounds like a problem, remember that:
-                        # if the parent was not already in our mainline
-                        # it would show up as a merge into this making
-                        # this not the end of a merge-line.
-                        lowest = len(merge_sorted)
-                        for parent_id in revisions[revid].parent_ids:
-                            if revs[parent_id][0] < lowest:
-                                lowest = revs[parent_id][0]
-                        assert lowest != len(merge_sorted)
-                        draw_line(h_idx, len(new_hanging), merge_sorted[lowest][1])
-                        drawn_parents.add(merge_sorted[lowest][1])
-                    elif len(revisions[revid].parent_ids) == 1:
-                        # only one parent, must show this link to be useful.
-                        parent_id = revisions[revid].parent_ids[0]
-                        draw_line(h_idx, len(new_hanging), parent_id)
-                        drawn_parents.add(parent_id)
-                
-                # what do we want to draw lines to from here:
-                # each parent IF its relevant.
-                #
-                # Now we need to hang its parents, we put them at the point
-                # the old column was so anything to the right of this has
-                # to move outwards to make room.  We also try and collapse
-                # hangs to keep the graph small.
-                # RBC: we do not draw lines to parents that were already merged
-                # unless its the last revision in a merge group.
-                for parent_id in revisions[revid].parent_ids:
-                    if parent_id in drawn_parents:
-                        continue
-                    parent_seq = revs[parent_id][0]
-                    parent_depth = revs[parent_id][1]
-                    if parent_depth == indent + 1:
-                        # The parent was a merge into this branch determine if
-                        # it was already merged into the mainline via a
-                        # different merge: if all revisions between us and
-                        # parent_seq have a indent greater than there are no
-                        # revisions with a lower indent than us.
-                        # We do not use 'parent_depth < indent' because that
-                        # would allow un-uniqueified merges to show up, and
-                        # merge_sorted should take care of that for us (but
-                        # does not trim the values)
-                        if parent_seq < next_lower_rev[revid]:
-                            draw_line(h_idx, len(new_hanging), parent_id)
-                    elif parent_depth == indent and parent_seq == seq + 1:
-                        # part of this branch
-                        draw_line(h_idx, len(new_hanging), parent_id)
-            else:
-                # draw a line from the previous position of this line to the 
-                # new position.
-                # h_idx is the old position.
-                # new_indent is the new position. 
-                draw_line(h_idx, len(new_hanging), hang)
-        # we've calculated the row, assign new_hanging to hanging to setup for
-        # the next row
-        hanging = new_hanging
-
-        yield (revisions[revid], node, lines)
-
-
-def same_branch(a, b):
-    """Return whether we think revisions a and b are on the same branch."""
-    if len(a.parent_ids) == 1:
-        # Defacto same branch if only parent
-        return True
-    elif a.committer == b.committer:
-        # Same committer so may as well be
-        return True
-    else:
-        return False

=== removed file 'olive/frontend/gtk/viz/graphcell.py'
--- olive/frontend/gtk/viz/graphcell.py	2006-08-10 17:25:30 +0000
+++ olive/frontend/gtk/viz/graphcell.py	1970-01-01 00:00:00 +0000
@@ -1,214 +0,0 @@
-# Modified for use with Olive:
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Original copyright holder:
-# Copyright (C) 2005 by Canonical Ltd. (Scott James Remnant <scott@ubuntu.com>)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Cell renderer for directed graph.
-
-This module contains the implementation of a custom GtkCellRenderer that
-draws part of the directed graph based on the lines suggested by the code
-in graph.py.
-
-Because we're shiny, we use Cairo to do this, and because we're naughty
-we cheat and draw over the bits of the TreeViewColumn that are supposed to
-just be for the background.
-"""
-
-__copyright__ = "Copyright © 2005 Canonical Ltd."
-__author__    = "Scott James Remnant <scott@ubuntu.com>"
-
-
-import math
-
-import gtk
-import gobject
-import pango
-import cairo
-
-
-class CellRendererGraph(gtk.GenericCellRenderer):
-    """Cell renderer for directed graph.
-
-    Properties:
-      node              (column, colour) tuple to draw revision node,
-      in_lines          (start, end, colour) tuple list to draw inward lines,
-      out_lines         (start, end, colour) tuple list to draw outward lines.
-    """
-
-    __gproperties__ = {
-        "node":         ( gobject.TYPE_PYOBJECT, "node",
-                          "revision node instruction",
-                          gobject.PARAM_WRITABLE
-                        ),
-        "in-lines":     ( gobject.TYPE_PYOBJECT, "in-lines",
-                          "instructions to draw lines into the cell",
-                          gobject.PARAM_WRITABLE
-                        ),
-        "out-lines":    ( gobject.TYPE_PYOBJECT, "out-lines",
-                          "instructions to draw lines out of the cell",
-                          gobject.PARAM_WRITABLE
-                        ),
-        }
-
-    def do_set_property(self, property, value):
-        """Set properties from GObject properties."""
-        if property.name == "node":
-            self.node = value
-        elif property.name == "in-lines":
-            self.in_lines = value
-        elif property.name == "out-lines":
-            self.out_lines = value
-        else:
-            raise AttributeError, "no such property: '%s'" % property.name
-
-    def box_size(self, widget):
-        """Calculate box size based on widget's font.
-
-        Cache this as it's probably expensive to get.  It ensures that we
-        draw the graph at least as large as the text.
-        """
-        try:
-            return self._box_size
-        except AttributeError:
-            pango_ctx = widget.get_pango_context()
-            font_desc = widget.get_style().font_desc
-            metrics = pango_ctx.get_metrics(font_desc)
-
-            ascent = pango.PIXELS(metrics.get_ascent())
-            descent = pango.PIXELS(metrics.get_descent())
-
-            self._box_size = ascent + descent + 6
-            return self._box_size
-
-    def set_colour(self, ctx, colour, bg, fg):
-        """Set the context source colour.
-
-        Picks a distinct colour based on an internal wheel; the bg
-        parameter provides the value that should be assigned to the 'zero'
-        colours and the fg parameter provides the multiplier that should be
-        applied to the foreground colours.
-        """
-        colours = [
-            ( 1.0, 0.0, 0.0 ),
-            ( 1.0, 1.0, 0.0 ),
-            ( 0.0, 1.0, 0.0 ),
-            ( 0.0, 1.0, 1.0 ),
-            ( 0.0, 0.0, 1.0 ),
-            ( 1.0, 0.0, 1.0 ),
-            ]
-
-        colour %= len(colours)
-        red   = (colours[colour][0] * fg) or bg
-        green = (colours[colour][1] * fg) or bg
-        blue  = (colours[colour][2] * fg) or bg
-
-        ctx.set_source_rgb(red, green, blue)
-
-    def on_get_size(self, widget, cell_area):
-        """Return the size we need for this cell.
-
-        Each cell is drawn individually and is only as wide as it needs
-        to be, we let the TreeViewColumn take care of making them all
-        line up.
-        """
-        box_size = self.box_size(widget)
-
-        cols = self.node[0]
-        for start, end, colour in self.in_lines + self.out_lines:
-            cols = max(cols, start, end)
-
-        width = box_size * (cols + 1)
-        height = box_size
-
-        # FIXME I have no idea how to use cell_area properly
-        return (0, 0, width, height)
-
-    def on_render(self, window, widget, bg_area, cell_area, exp_area, flags):
-        """Render an individual cell.
-
-        Draws the cell contents using cairo, taking care to clip what we
-        do to within the background area so we don't draw over other cells.
-        Note that we're a bit naughty there and should really be drawing
-        in the cell_area (or even the exposed area), but we explicitly don't
-        want any gutter.
-
-        We try and be a little clever, if the line we need to draw is going
-        to cross other columns we actually draw it as in the .---' style
-        instead of a pure diagonal ... this reduces confusion by an
-        incredible amount.
-        """
-        ctx = window.cairo_create()
-        ctx.rectangle(bg_area.x, bg_area.y, bg_area.width, bg_area.height)
-        ctx.clip()
-
-        box_size = self.box_size(widget)
-
-        ctx.set_line_width(box_size / 8)
-        ctx.set_line_cap(cairo.LINE_CAP_SQUARE)
-
-        # Draw lines into the cell
-        for start, end, colour in self.in_lines:
-            ctx.move_to(cell_area.x + box_size * start + box_size / 2,
-                        bg_area.y - bg_area.height / 2)
-
-            if start - end > 1:
-                ctx.line_to(cell_area.x + box_size * start, bg_area.y)
-                ctx.line_to(cell_area.x + box_size * end + box_size, bg_area.y)
-            elif start - end < -1:
-                ctx.line_to(cell_area.x + box_size * start + box_size,
-                            bg_area.y)
-                ctx.line_to(cell_area.x + box_size * end, bg_area.y)
-
-            ctx.line_to(cell_area.x + box_size * end + box_size / 2,
-                        bg_area.y + bg_area.height / 2)
-
-            self.set_colour(ctx, colour, 0.0, 0.65)
-            ctx.stroke()
-
-        # Draw lines out of the cell
-        for start, end, colour in self.out_lines:
-            ctx.move_to(cell_area.x + box_size * start + box_size / 2,
-                        bg_area.y + bg_area.height / 2)
-
-            if start - end > 1:
-                ctx.line_to(cell_area.x + box_size * start,
-                            bg_area.y + bg_area.height)
-                ctx.line_to(cell_area.x + box_size * end + box_size,
-                            bg_area.y + bg_area.height)
-            elif start - end < -1:
-                ctx.line_to(cell_area.x + box_size * start + box_size,
-                            bg_area.y + bg_area.height)
-                ctx.line_to(cell_area.x + box_size * end,
-                            bg_area.y + bg_area.height)
-
-            ctx.line_to(cell_area.x + box_size * end + box_size / 2,
-                        bg_area.y + bg_area.height / 2 + bg_area.height)
-
-            self.set_colour(ctx, colour, 0.0, 0.65)
-            ctx.stroke()
-
-        # Draw the revision node in the right column
-        (column, colour) = self.node
-        ctx.arc(cell_area.x + box_size * column + box_size / 2,
-                cell_area.y + cell_area.height / 2,
-                box_size / 4, 0, 2 * math.pi)
-
-        self.set_colour(ctx, colour, 0.0, 0.5)
-        ctx.stroke_preserve()
-
-        self.set_colour(ctx, colour, 0.5, 1.0)
-        ctx.fill()

=== renamed file 'olive/frontend/gtk/handler.py' => 'olive/handler.py'
=== renamed file 'olive/frontend/gtk/info.py' => 'olive/info.py'
=== renamed file 'olive/frontend/gtk/log.py' => 'olive/log.py'
=== renamed file 'olive/frontend/gtk/menu.py' => 'olive/menu.py'
=== renamed file 'olive/frontend/gtk/mkdir.py' => 'olive/mkdir.py'
=== renamed file 'olive/frontend/gtk/move.py' => 'olive/move.py'
=== renamed file 'olive/frontend/gtk/push.py' => 'olive/push.py'
=== renamed file 'olive/frontend/gtk/remove.py' => 'olive/remove.py'
=== renamed file 'olive/frontend/gtk/rename.py' => 'olive/rename.py'
=== renamed file 'olive/frontend/gtk/status.py' => 'olive/status.py'
=== renamed file 'olive/frontend/gtk/ui.py' => 'olive/ui.py'
